/*
 *Langton's Crack Smoking, Steroid Pumping, Ass Kicking Ant
 *  
 *  Copyright (c) 1999 Matt Chisholm, Jeremy Avnet, Brian Martin
 *     and the SRO - www.theory.org - strthrwr@prtr-13.ucsc.edu
 *
 *  Should compile with g++ -lm -lpng -lz `gtk-config --libs` langton.c
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <png.h>

//we need this
typedef struct video {
  char bytes;//bit depth
  short width;//image width
  short height;//image height
  char mag;//image magnification
} Video;

//I am satan because I use globals. Thbbbbt.
Video video;
GtkWidget * window; //this holds the pointer to the gtk window
int ** location; //ant's location and direction
int ** oldlocation; //ant's past location and direction, for computation
int ** space; //space where calculation is done
int keepgoing = 1; //for checking once ants fly out of window
char debug = 0; 
int torus = 0; //do we want to play on a torus
int channels = 1; //channels in png file
int custants = 0; //do we want to customize our ant locations?
int foundants = 0; //did we find ants on the image? 
int ants = 1; //how many ants do we want
int ant_id = 0;//tells makenewlocation which ant we are on. 

int ** makenewlocation(int ** space, Video video){//recalculates ant location and direction
  int x, y;
  //location: [ant_id] which ant we are manipulating 
  //[0] x coord, [1] y coord, [2] x direction just traveled in [3] y direction just traveled in
  //printf("%d\n", ant_id);
  //printf("%d in %d, %d\t", ant_id, location[ant_id][2], location[ant_id][3]);
  for (ant_id = 0; ant_id < ants; ant_id++){
    oldlocation[ant_id][0] = location[ant_id][0]; 	
    oldlocation[ant_id][1] = location[ant_id][1]; 
    oldlocation[ant_id][2] = location[ant_id][2];
    oldlocation[ant_id][3] = location[ant_id][3];
    if (space[location[ant_id][1]][location[ant_id][0]] == 1){
      //then we're on white
      space[location[ant_id][1]][location[ant_id][0]] = 0;
      //rotate vector ccw
      location[ant_id][2] = -oldlocation[ant_id][3]; 
      location[ant_id][3] = oldlocation[ant_id][2]; 
      //move in the direction of the vector
      location[ant_id][0] = oldlocation[ant_id][0]+location[ant_id][2]; 
      location[ant_id][1] = oldlocation[ant_id][1]+location[ant_id][3];
    } else if (space[location[ant_id][1]][location[ant_id][0]] == 0){
      //then we're on black
      space[location[ant_id][1]][location[ant_id][0]] = 1;
      //rotate vector cw
      location[ant_id][2] = oldlocation[ant_id][3]; 
      location[ant_id][3] = -oldlocation[ant_id][2]; 
      //move in the direction of the vector
      location[ant_id][0] = oldlocation[ant_id][0]+location[ant_id][2]; 
      location[ant_id][1] = oldlocation[ant_id][1]+location[ant_id][3];
    }
    if ((location[ant_id][0] > video.width-1) || (location[ant_id][1] > video.height-1) || (location[ant_id][0] < 0) || (location[ant_id][1] < 0)){
      if (torus == 1){//play on a torus
	if (location[ant_id][0] < 0){
	  location[ant_id][0] = video.width-1; 
	} else if (location[ant_id][0] > video.width-1){
	  location[ant_id][0] = 0; 
	}
	if (location[ant_id][1] < 0){
	  location[ant_id][1] = video.height-1; 
	} else if (location[ant_id][1] > video.height-1){
	  location[ant_id][1] = 0; 
	}
      } else  if (torus == -1){//play on a klein bottle
	if (location[ant_id][0] < 0){
	  location[ant_id][0] = video.width-1; 
	  location[ant_id][1] = video.height-1-location[ant_id][1];
	} else if (location[ant_id][0] > video.width-1){
	  location[ant_id][0] = 0; 
	  location[ant_id][1] = video.height-1-location[ant_id][1];
	}
	if (location[ant_id][1] < 0){
	  location[ant_id][1] = video.height-1; 
	} else if (location[ant_id][1] > video.height-1){
	  location[ant_id][1] = 0; 
	}
      } else{ //playing on a square
	location[ant_id][0] = oldlocation[ant_id][0]; 
	location[ant_id][1] = oldlocation[ant_id][1]; 
	printf ("Ant out of bounds at %d, %d\n", location[ant_id][0], location[ant_id][1]); 
	keepgoing = 0;
      }
    } 
  }
  return location;
}

void init_window(int ** space, Video video, GtkWidget * window){
//draws in whole window before iterating
  int x, y, i, j;
  unsigned char pixel[3]; 
  for (y = 0; y < video.height; y++){
    for (x = 0; x < video.width; x++){    
      for (j = 0; j < video.mag; j++){
	for (i = 0; i < video.mag; i++){
	  pixel[0] = pixel[1] = 0xFF*space[y][x];
	  //make unvisited white points slightly yellow, 
	  //and unvisited black points slightly blue
	  pixel[2] = (unsigned char)(0xFF*((1.0/3.0)+(double)space[y][x]/3.0));
	  gtk_preview_draw_row( GTK_PREVIEW(window), pixel, (x*video.mag+i), (y*video.mag+j), 1);
	}
      }
    }
  }
  gtk_widget_draw(window,NULL); /* what does this do? */
  gdk_flush(); /* or this? */
}//end init_space

void previewit(GtkWidget * window , Video video) //draws to the screen
{
  short x, y, i, j, a;
  short height = video.height; 
  short width = video.width;
  unsigned char pixel[3];
  //this formerly hideous routine sets the "space" parameters into the image 
  //at the same time it scales the image to fit the window. Enjoy! 
  //you're where the ant just left. we'll color you accordingly.
  for (a = 0; a < ants; a++){
    x = oldlocation[a][0]; 
    y = oldlocation[a][1]; 
    for (j =0; j < video.mag; j++){ 
      for (i = 0;  i < video.mag; i++) {
	pixel[0] = pixel[1] = pixel[2] = 0xff*space[y][x];
	gtk_preview_draw_row( GTK_PREVIEW(window),pixel, (x*video.mag+i), (y*video.mag+j), 1);
      }
    }
  }
  //hey! you are the ant! we'll make you red. 
  for (a = 0; a < ants; a++){
    x = location[a][0]; 
    y = location[a][1]; 
    for (j =0; j < video.mag; j++){ 
      for (i = 0; i < video.mag; i++) {
	pixel[0] = 0xff;
	pixel[1] = pixel[2] = 0;
	gtk_preview_draw_row( GTK_PREVIEW(window),pixel, (x*video.mag+i), (y*video.mag+j), 1);
      }
    }
  }
  //put the whole thing into the window in one step
  gtk_widget_draw(window,NULL); /* what does this do? */
  gdk_flush(); /* or this? */
}

unsigned char ** readpng(char * filename){
  png_structp png_ptr;	  // don't ask, don't tell
  png_infop info_ptr;     // info about png file
  int number = 8;
  int i, x, y; 
  //int channels; 
  long unsigned int width, height;
  //char * header;
  //int is_png; 
  //unsigned char * header = calloc(number, sizeof(unsigned char)); 
  void * header;
  unsigned char ** row_array;

  FILE *fp = fopen(filename, "rb");
  if (!fp){
    return(0);
  }
  //is it a png? 
  //someone please tell me what the fuck "header" is supposed to be!
  /*
  fread(header, 1, number, fp);
    is_png = png_check_sig(header, number);
  if (!is_png){
    printf("shit!\n"); 
    return;
    }
  png_set_sig_bytes(png_ptr, number);
  */
  //do what man libpng says. I'll be 73.45211 years old before I grok this.
  /*
  png_ptr = png_create_read_struct
    (PNG_LIBPNG_VER_STRING, (png_voidp)user_error_ptr,
     user_error_fn, user_warning_fn);
  */
  png_ptr = png_create_read_struct
    (PNG_LIBPNG_VER_STRING, (png_voidp)NULL,NULL,NULL);
  if (!png_ptr){
    printf("bad png_create_read_struct\n"); 
    return(0);
  }
  info_ptr = png_create_info_struct(png_ptr);
  if (!info_ptr){
    png_destroy_read_struct(&png_ptr,
			    (png_infopp)NULL, (png_infopp)NULL);
    printf("bad png_create_info_struct\n"); 
    return(0);
  }
  png_infop end_info = png_create_info_struct(png_ptr);
  if (!end_info){
    png_destroy_read_struct(&png_ptr, &info_ptr,
			    (png_infopp)NULL);
    printf("bad png_create_info_struct\n"); 
    return(0);
  }
  //set up
  png_init_io(png_ptr, fp);
  png_read_info(png_ptr, info_ptr);
  //read height & width
  height = png_get_image_height(png_ptr, info_ptr);
  width = png_get_image_width(png_ptr, info_ptr);
  channels = png_get_channels(png_ptr, info_ptr);
  //"horses contributed to the patriarchy."
  //make Mr. Box to put Mr. Data in. 
  row_array = (unsigned char **)calloc(height, sizeof(char *));
  for (i = 0; i < height; i++) {
    row_array[i] = (unsigned char *)calloc(width*channels, sizeof(unsigned char));
  }
  //read Mr. Data into Mr. Box
  png_read_image(png_ptr, row_array);
  fclose(fp);
  video.height = height; 
  video.width = width; 
  return(row_array);
}

void main(int argc, char *argv[]) {
  int i;
  GtkWidget * window1;
  int x, y;
  //set default variables
  int randomize = 0;
  int randomness = 100;
  int readfile = 0; 
  char * filename;
  int start = 1;
  //set default video variables
  video.width  = 100;
  video.height = 100;
  video.bytes  = 3;
  video.mag = 2;
  unsigned char ** row_array; 

  //read argyments
  for (i = 0; i < argc; i++){
    if (strcmp(argv[i], "-r") == 0){
      randomize = 1;
      randomness = atoi(argv[++i]);
      printf("Randomizing.\n"); 
    } 
    else if (strcmp(argv[i], "-s") == 0){
      video.width = atoi(argv[++i]); 
      video.height = atoi(argv[++i]);
      printf("Sizing.\n");
    }
    else if (strcmp(argv[i], "-f") == 0){
      readfile = 1;
      filename = argv[++i]; 
      printf("Reading file %s. \n", filename);
    }
    else if (strcmp(argv[i], "-m") == 0){
      video.mag = atoi(argv[++i]); 
      printf("Scaling.\n");
    }
    else if (strcmp(argv[i], "-t") == 0){
      torus = 1; 
      printf("Torus.\n");
    }
    else if (strcmp(argv[i], "-k") == 0){
      torus = -1; 
      printf("Klein Bucket.\n");
    } 
    else if (strcmp(argv[i], "-a") == 0){
      ants = atoi(argv[++i]);
      custants = 1;
    }
    else if ((strcmp(argv[i], "-h") == 0) ||(strcmp(argv[i], "-help") == 0)) {
      printf("Langton's Ant by the SRO - www.theory.org
Options:
-s [WIDTH] [HEIGHT]
-m [MAGNIFICATION FACTOR]
-r [NUMBER] , 1 out of number pixels is inverted
-f [FILENAME.PNG] , use a png to specify starting configuration.
-t , play on a torus.
-k , play on a klein bottle.
-a [NUMBER OF ANTS] , multiple ant mode:
   if loading png, places n ants at the first n pixels found with color ff0000
   otherwise will place n ants randomly about the field.\n"); 
      exit(0);
    }
  }
  //if (start == 1){// if user's asked for help, don't do anything else.

    //read png to get video width and height and row_array and ant starting posn.
    if (readfile){
      row_array = readpng(filename);
    }

    //make space
    space = (int **)calloc(video.height, sizeof(int *));
    for (i = 0; i < video.height; i++) {
      space[i] = (int *)calloc(video.width, sizeof(int));
    }
    
    //make it black all over
    for (y = 0; y < video.height; y++){
      for (x = 0; x < video.width; x++){
	space[y][x] = 0; 
      }
    }
    
    //set png contents into space
    if (readfile){
      for (y = 0; y < video.height; y++){
	for (x = 0; x < video.width; x++){
	  space[y][x] = (int)row_array[y][x*channels]/(int)255; 
	}
      }
    }
    
    /*fill our state with noise*/
    if(randomize){
      for (y = 0; y < video.height; y++){
	for (x = 0; x < video.width; x++){
	  if (rand() % randomness){
	    //do nothing
	  } else {
	    //invert whatever's there
	    if (space[y][x] == 0){
	      space[y][x] = 1; 
	    } else if (space[y][x] == 1){
	      space[y][x] = 0; 
	    }
	  }
	}
      }
    }

    //make location
    location = (int **)calloc(ants, sizeof(int *));
    for (i = 0; i < ants; i++){
      location[i] = (int *)calloc(4, sizeof(int)); 
    }

    //make oldlocation
    oldlocation = (int **)calloc(ants, sizeof(int *)); 
    for (i = 0; i < ants; i++){
      oldlocation[i] = (int *)calloc(4, sizeof(int)); 
    }
    
    //customize ant locations
    if (custants){
      if (readfile){//put ants at red dots
	i = 0; 
	printf("%d possible ants.\n", ants); 
	if (channels == 3){
	  for (y = 0; y < video.height; y++){
	    for (x = 0; x < video.width; x++){
	      if ( i < ants ){
		if ((row_array[y][x*channels] == 255) && (row_array[y][x*channels+1] == 0) && (row_array[y][x*channels+2] == 0)){
		  printf("Found ant %d at (%d, %d).\n", i+1, x, y); 
		  location[i][0] = x; 
		  location[i][1] = y;
		  i++;
		  foundants = 1; 
		}
	      }
	    }
	  }
	  printf("Finishing at (%d, %d) after finding %d ants.\n", x, y, i);
	} else {
	  printf("Not a color image. No ants found.\n");
	}
	if (foundants){
	  ants = i; 
	}
      }
      if (!foundants) {//use random locations
	printf("Making random ant locations!\n");
	srand(time(NULL));
	for (i = 0; i < ants; i++){
	  location[i][0] = rand()%video.width; 
	  location[i][1] = rand()%video.height;
	  printf("Ant %d: (%d, %d)\n", i+1, location[i][0], location[i][1]); 
	}
      }
      for (i = 0; i < ants; i++){
	location[i][2] = 0; 
	location[i][3] = 1; 
      }
    } else { //there's only one ant, and it's not customized 
      location[0][0] = video.width/2; 
      location[0][1] = video.height/2;
      location[0][2] = 0; 
      location[0][3] = 1;  
    } //end custants

    //gtk boolsheeot
    gtk_init (&argc, &argv);
    window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (window1), "Langton's Crack Smoking, Steroid Pumping, Ass Kicking Ants");
    gtk_signal_connect (GTK_OBJECT (window1), "delete_event",
			GTK_SIGNAL_FUNC (&gtk_main_quit), NULL);
    window = gtk_preview_new(GTK_PREVIEW_COLOR);
    gtk_container_add (GTK_CONTAINER (window1), window);
    gtk_preview_size (GTK_PREVIEW (window), video.width * video.mag, video.height * video.mag);
    gtk_widget_show(window);
    gtk_widget_show(window1);
    
    //put stuff in gtk window
    init_window(space, video, window);

    //update gtk window
    while(keepgoing == 1){
      previewit(window, video); //update window
      location = makenewlocation(space, video); //update ants
    }
    //redowrwaw wiiing-ding-dingdow
    gtk_main(); 
    printf("Thanks for using Langton's Crack Smoking, Steroid Pumping, Ass Kicking Ant. Come back soon!\n");
    //}//end if start = 1 (when user asks for help)
}
